module paint_mod
!!! pass the function calc_cut an image, eigenvector, a cut threshold, and a weight matrix 
!!! and it will return the normalized cut value 
contains
  real function calc_cut(eig_vec,cut_val,wt_mat)
    real,  dimension(:)	                                :: eig_vec,eig_vec_split
    real,  dimension(:,:)	                                :: wt_mat
    real							::cut_val,cutsum,assoc_A,assoc_B 
    integer							:: ix,iy,eig_sz,cnter,cnter_2
!!$
!!$write(0,*) 'cut_val', cut_val
!!$write(0,*) 'eig_vec',maxval(eig_vec),minval(eig_vec)
!!$write(0,*) eig_vec

    allocate(eig_vec_split(size(eig_vec)))
    eig_vec_split=0.
    eig_sz=size(eig_vec)
    !  write(0,*) 'eig_vec', eig_vec
    cnter=0
    cnter_2=0
    do ix=1,eig_sz
       if (eig_vec(ix)>=cut_val) then
          eig_vec_split(ix)=1  !%group A
          cnter=cnter+1 
       else
          eig_vec_split(ix)=0  !% group B
          cnter_2=cnter_2+1
       end if
    end do
    write(0,*) 'number of nodes in group A',cnter
    write(0,*) 'number of nodes in group B',cnter_2
    cutsum=0;
    !  %calculate cut, numerator
    !  %for each column in wt_mat in group A, sum all the rows in group B
    do iy=1,eig_sz
       if (eig_vec_split(iy)==1) then ! % is in group A?
          do ix=1,eig_sz
             if (eig_vec_split(ix)==0) then !%is the row in group B?
                cutsum=cutsum+wt_mat(ix,iy)
             end if
          end do
       end if
    end do

    assoc_A=0;
    assoc_B=0;
    !       %calculate assocations for group A and B.  basically, calculate all of the
    !      %connections for all nodes in group A.
    do iy=1,eig_sz
       if (eig_vec_split(iy)==1)  then !%is in group A? if so sum the columns
          assoc_A=assoc_A+sum(wt_mat(:,iy))   !% the -1 is for the diagonal....UNCERTAIN
       else  !% implies the column is in group B
          assoc_B=assoc_B+sum(wt_mat(:,iy))
       end if
    end do

    calc_cut= cutsum/assoc_A+cutsum/assoc_B
    deallocate(eig_vec_split) 
  end function calc_cut


  real function calc_cut_sparse(eig_vec,cut_val,sparse_mat)
    real,  dimension(:)	                                :: eig_vec,eig_vec_split
    real,  dimension(:,:)	                                :: sparse_mat
    real							::cut_val,cutsum,assoc_A,assoc_B 
    integer							:: ix,iy,eig_sz,cnter,cnter_2,sparse_sz
!!$
!!$write(0,*) 'cut_val', cut_val
!!$write(0,*) 'eig_vec',maxval(eig_vec),minval(eig_vec)
!!$write(0,*) eig_vec

    allocate(eig_vec_split(size(eig_vec)))
    eig_vec_split=0.
    eig_sz=size(eig_vec)
    sparse_sz=size(sparse_mat(1:,1))
    !  write(0,*) 'eig_vec', eig_vec
    cnter=0
    cnter_2=0
    do ix=1,eig_sz
       if (eig_vec(ix)>=cut_val) then
          eig_vec_split(ix)=1  !%group A
          cnter=cnter+1 
       else
          eig_vec_split(ix)=0  !% group B
          cnter_2=cnter_2+1
       end if
    end do
    write(0,*) 'number of nodes in group A',cnter
    write(0,*) 'number of nodes in group B',cnter_2
    cutsum=0;
    !  %calculate cut, numerator
    !  %for each column in wt_mat in group A, sum all the rows in group B
    do ix=1,sparse_sz
       if (eig_vec_split (nint(sparse_mat(ix,2)))==1) then ! is this column in group A?
          if (eig_vec_split (nint(sparse_mat(ix,1)))==0) then ! is its row is group B?
             cutsum=cutsum+sparse_mat(ix,3)
          end if
       end if
    end do

    assoc_A=0;
    assoc_B=0;
    !       %calculate assocations for group A and B.  basically, calculate all of the
    !      %connections for all nodes in group A.
    do ix=1, sparse_sz
       if (eig_vec_split(nint(sparse_mat(ix,2))==1)) then !is this column value in group A? 
          assoc_A=assoc_A+sparse_mat(ix,3)
       else  ! then it is in group B
          assoc_B=assoc_B+sparse_mat(ix,3)
       end if
    end do

    !write(0,*) 'assoc_A',assoc_A
    !write(0,*) 'assoc_B',assoc_B


    deallocate(eig_vec_split)
write(0,*) 'cutsum', cutsum

    calc_cut_sparse= (cutsum*assoc_A)/(.000001+assoc_A**2)+(cutsum*assoc_B)/(.000001*assoc_B**2)
  end function calc_cut_sparse



  real function calc_cut_sparse2(eig_vec,cut_val,sparse_mat)
    real,  dimension(:)	                                :: eig_vec,eig_vec_split
    real,  dimension(:,:)	                                :: sparse_mat
    real							::cut_val,cutsum,assoc_A,assoc_B 
    integer							:: ix,iy,eig_sz,cnter,cnter_2,sparse_sz
!!$
!!$write(0,*) 'cut_val', cut_val
!!$write(0,*) 'eig_vec',maxval(eig_vec),minval(eig_vec)
!!$write(0,*) eig_vec

    allocate(eig_vec_split(size(eig_vec)))
    eig_vec_split=0.
    eig_sz=size(eig_vec)
    sparse_sz=size(sparse_mat(1:,1))
    !  write(0,*) 'eig_vec', eig_vec
    cnter=0
    cnter_2=0
    do ix=1,eig_sz
       if (eig_vec(ix)>=cut_val) then
          eig_vec_split(ix)=1  !%group A
          cnter=cnter+1 
       else
          eig_vec_split(ix)=0  !% group B
          cnter_2=cnter_2+1
       end if
    end do
    write(0,*) 'number of nodes in group A',cnter
    write(0,*) 'number of nodes in group B',cnter_2
    cutsum=0;
    !  %calculate cut, numerator
    !  %for each column in wt_mat in group A, sum all the rows in group B
    do ix=1,sparse_sz
       if (eig_vec_split (nint(sparse_mat(ix,2)))==1) then ! is this column in group A?
          if (eig_vec_split (nint(sparse_mat(ix,1)))==0) then ! is its row is group B?
             cutsum=cutsum+sparse_mat(ix,3)
          end if
       end if
    end do

    assoc_A=0;
    assoc_B=0;
    !       %calculate assocations for group A and B.  basically, calculate all of the
    !      %connections for all nodes in group A.
    do ix=1, sparse_sz
       if (eig_vec_split(nint(sparse_mat(ix,2))==1)) then !is this column value in group A? 
          assoc_A=assoc_A+sparse_mat(ix,3)
       else  ! then it is in group B
          assoc_B=assoc_B+sparse_mat(ix,3)
       end if
    end do

    !write(0,*) 'assoc_A',assoc_A
    !write(0,*) 'assoc_B',assoc_B


    deallocate(eig_vec_split)

  !  calc_cut_sparse= (cutsum*assoc_A)/(.000001+assoc_A**2)+(cutsum*assoc_B)/(.000001*assoc_B**2)
     calc_cut_sparse2 = cutsum !(cutsum*assoc_A)/(.000001+assoc_A**2)+(cutsum*assoc_B)/(.000001*assoc_B**2)
  end function calc_cut_sparse2

  subroutine make_simple_model(model)
    real,dimension(:,:)   :: model
    real                  ::radius,shift
    integer               ::ix,iy,n1,n2
    n1=size(model(1:,1))
    n2=size(model(1,1:))
    write(0,*) n1,n2
    model=1.
    radius=n2/3
    do iy=1,radius
       shift=max(min(sqrt(radius**2.-(iy)**2.),n2-1),1.)
       write(0,*) real(n2/2),shift,nint(real(shift))
       model(iy,nint(real(shift)):nint(real(shift))+1)=0.2

    end do
    !model(nint(n1/2.)-10:nint(n1/2.)+10,1:)=1.
    !model(15:20,3*n2/4:1+3*n2/4)=0.2
    !model(15,3*n2/4:)=0.2
    !stop
  end subroutine make_simple_model


  subroutine make_cube(model)
    real,dimension(:,:,:)   :: model
    real                  ::shift
    integer               ::ix,iy,n1,n2,n3
    n1=size(model(1:,1,1))
    n2=size(model(1,1:,1))
    n3=size(model(1,1,1:))
    write(0,*) n1,n2,n3
    model=1.

    do iy=1,n3/2
       do ix=n2/2,n2
          model(nint(real(n1)/2.),ix,iy)=0.2
       end do
model(nint(real(n1)/2.):,nint(real(n2)/2.),iy)=.2
       !model(nint(n1/2)-10:nint(n1/2)+10,1:)=1.
       !model(15:20,3*n2/4:1+3*n2/4)=0.2
       !model(15,3*n2/4:)=0.2
       !stop
    end do
model(nint(real(n1)/2.):,nint(real(n2)/2.):,n3/2)=.2

!!$model=1.
!!$model(:,n2/2:n2/2+1,:)=.2

  end subroutine make_cube



!!$  
!!$    subroutine make_weight(norm_d,sparse_mat)
!!$      real,dimension(:,:)::norm_d,sparse_mat
!!$      integer :: matlen,icol,irow,inonzero,nt,nx
!!$      real :: phiI,phiX,icol1_rl,irow1_rl,icol2_rl,irow2_rl,max_dist,dist,dist_exp
!!$      nt=size(norm_d(1:,1))
!!$      nx=size(norm_d(1,1:))
!!$      phiI=.1
!!$      phiX=4.
!!$      max_dist=7.
!!$      inonzero=1
!!$
!!$   !   allocate(sparse_mat(1,3))
!!$      do icol=1,nx*nt
!!$         do irow=1,nx*nt
!!$            icol_rl=icol
!!$            irow_rl=irow
!!$            row1=floor((icol_rl-1.)/nx)+1
!!$            col1=icol_rl-(row1-1)*nx;
!!$
!!$            row2=floor((irow_rl-1.)/nx)+1
!!$            col2=irow_rl-(row2-1)*nx
!!$            row1_rl=row1
!!$            col1_rl=col1
!!$            row2_rl=row2
!!$            col2_rl=col2
!!$
!!$
!!$            dist=sqrt((row1_rl-row2_rl)**2+(col1_rl-col2_rl)**2)
!!$            if (dist>max_dist) then !was 7 ! was 5.
!!$               !     dist_exp=0.
!!$            else
!!$               dist_exp=exp(-dist/(phiX**2))
!!$               !      end if
!!$               !     W_mat(icol,irow)=exp(-(norm_d(row1,col1)-norm_d(row2,col2))**2/(phiI**2))*dist_exp
!!$
!!$               sparse_mat(inonzero,1)=irow
!!$               sparse_mat(inonzero,2)=icol
!!$               sparse_mat(inonzero,3)=exp(-(norm_d(row1,col1)-norm_d(row2,col2))**2/(phiI**2))*dist_exp
!!$               inonzero=inonzero+1
!!$
!!$               allocate(sparse_mat2(inonzero-1,3))
!!$               sparse_mat2=sparse_mat
!!$               deallocate(sparse_mat)
!!$               allocate(sparse_mat(inonzero,3))
!!$               sparse_mat(1:inonzero-1,1:)=sparse_mat2
!!$               deallocate(sparse_mat2)
!!$
!!$            end if
!!$         end do
!!$      end do
!!$    end subroutine make_weight

  subroutine make_sparse(mat,sparse_mat)
    !    real,dimension(:,:)   :: model
    real, dimension(:,:)::mat,sparse_mat  !!!2d array::  nnonzero X 3
    integer               ::irow,icol,nrow,ncol,inonzero,nnonzero,nWeight
    nnonzero=size(sparse_mat(1:,1))
    nWeight=size(mat(1:,1))
    !   nrow=size(mat(1,1:))
    inonzero=1
    do irow=1,nWeight
       do icol=1,nWeight
          if (mat(irow,icol)/=0) then
             sparse_mat(inonzero,1)=irow
             sparse_mat(inonzero,2)=icol
             sparse_mat(inonzero,3)=mat(irow,icol)
             inonzero=inonzero+1
          end if
       end do
    end do


  end subroutine make_sparse

  subroutine sparse_mat_mult(mat,vec,mat_vec,nt,nx,ny)
    integer               ::irow,icol,nrow,ncol,inonzero,nnonzero,nt,nx,ny
    real, dimension(:,:)::mat  !!!2d array::  nnonzero X 3
    real,dimension(:)::vec(nt*nx*ny),mat_vec(nt*nx*ny)

    nnonzero=size(mat(1:,1))
    mat_vec=0.
    do inonzero=1,nnonzero
       irow=mat(inonzero,1)
       icol=mat(inonzero,2)
       mat_vec(irow)=mat_vec(irow)+mat(inonzero,3)*vec(icol)
    end do
    !     mat_vec=mat_vec*25
  end subroutine sparse_mat_mult

  subroutine weight_to_data(nx,icol_wt,irow_wt,icol1_dat,irow1_dat,icol2_dat,irow2_dat) 
    !this converts weight matrix indicies into the 2 data matrix nodes they correspond to
    !nx is the width of the data matrix
    integer               ::icol_wt,irow_wt,icol1_dat,irow1_dat,icol2_dat,irow2_dat,nx
    real                  ::icol_rl,irow_rl
    icol_rl=icol_wt
    irow_rl=irow_wt
    irow1_dat=floor((icol_rl-1.)/real(nx))+1
    icol1_dat=icol_rl-(irow1_dat-1)*real(nx);

    irow2_dat=floor((irow_rl-1.)/real(nx))+1
    icol2_dat=irow_rl-(irow2_dat-1)*real(nx)
  end subroutine weight_to_data
  subroutine weight_to_data_3D(nt,nx,icol_wt,irow_wt,icolx1_dat,icoly1_dat,irow1_dat,icolx2_dat,icoly2_dat,irow2_dat) 
    !this converts weight matrix indicies into the 3 data matrix nodes they correspond to
    !nx is the width of the data cube,nt is the height of the cube
    integer               ::icol_wt,irow_wt,icol1_dat,irow1_dat,icol2_dat,irow2_dat,nx,nt
    real                  ::icol_rl,irow_rl
    icol_rl=icol_wt
    irow_rl=irow_wt

    icoly1_dat   =   floor((icol_rl-1.)/(real(nt*nx)))+1                     ! plane 
    irow1_dat    =   floor((icol_rl-(icoly1_dat-1)*real(nx*nt)-1)/nx)+1    ! row
    icolx1_dat   =   icol_rl-(icoly1_dat-1)*real(nx*nt)-(irow1_dat-1)*real(nx)  ! colx

    icoly2_dat   =   floor((irow_rl-1.)/real(nt*nx))+1                     ! plane
    irow2_dat    =   floor((irow_rl-(icoly2_dat-1)*real(nx*nt)-1)/real(nx))+1    ! row 
    icolx2_dat   =   irow_rl-(icoly2_dat-1)*real(nx*nt)-(irow2_dat-1)*real(nx)! ! colx


  end subroutine weight_to_data_3D

  subroutine data_to_weight_3D(nt,nx,icol_wt,irow_wt,icolx1_dat,icoly1_dat,irow1_dat,icolx2_dat,icoly2_dat,irow2_dat) 
    !this converts 3 data nodes into the indicies of the weight matrix
    integer               ::icol_wt,irow_wt,icolx1_dat,icoly1_dat,irow1_dat,icolx2_dat,icoly2_dat,irow2_dat,nx,nt

    icol_wt=(icoly1_dat-1)*real(nt*nx) + (irow1_dat-1)*real(nx)  + icolx1_dat
    irow_wt=(icoly2_dat-1)*real(nt*nx) + (irow2_dat-1)*real(nx)  + icolx2_dat


  end subroutine data_to_weight_3D

  subroutine data_to_weight(nx,icol_wt,irow_wt,icol1_dat,irow1_dat,icol2_dat,irow2_dat) 
    !this converts 2 data nodes into the indicies of the weight matrix
    integer               ::icol_wt,irow_wt,icol1_dat,irow1_dat,icol2_dat,irow2_dat,nx



    icol_wt=(irow1_dat-1)*real(nx)+icol1_dat
    irow_wt=(irow2_dat-1)*real(nx)+icol2_dat

  end subroutine data_to_weight




end module paint_mod
