module warp_mod
! Find the minimim of nearby warped wakes.  min_wake_position identifys the warped wake that is 
! within the contraints and mininum
!
use sorting_mod
contains 
  subroutine min_wake(wrp_wks,cst_wks,i,j,new_i,new_j,sd,wake_counter,min_wake_position)
    integer 	                          :: i,j,new_i,new_j,old_i,old_j
    integer                               :: ig,sd,min_wake_position,wake_counter 
    !integer, dimension (:), allocatable  ::
    integer,    dimension (:,:,:,:)       :: wrp_wks
    real                                  :: min_wake_value
    real,    dimension (:)                :: cst_wks


    min_wake_value=cst_wks(1)
    min_wake_position=1


    ! make a list of nearby warped wakes
    wakeloop: do ig=1,wake_counter  !loop over each wake
       old_i=wrp_wks(i-1,j,1,ig)  ;  old_j=wrp_wks(i-1,j,2,ig)

       nearby: if (new_i-sd    <=old_i  .and.new_i   >=old_i.and.\
          new_j-sd/2  <=old_j  .and.new_j+sd/2>=old_j) then

          if (cst_wks(ig)<min_wake_value) then 
             min_wake_value=cst_wks(ig)
             min_wake_position=ig
          end if

       end if nearby
    end do wakeloop

 end subroutine min_wake

 subroutine beam_wake_list(wrp_wks,cst_wks,add_cost,i,j,new_i,new_j,sd,wake_counter,min_wake_position,beam_list,sol_counter,beam_list_counter)
   !!  Take each new_i,new_j pair and scans over all nearby warped wakes and costs
   !!
   integer 	                          :: i,j,new_i,new_j,old_i,old_j,ir
   integer                               :: ig,sd,min_wake_position,wake_counter
   integer                               :: n1_long,n1, n2,sol_counter
   integer                               :: beam_list_counter
   integer,    dimension (:,:,:,:)       :: wrp_wks
   real                                  :: min_wake_value,add_cost
   real,    dimension (:)                :: cst_wks
   real,    dimension (:,:)                :: beam_list
   real,    dimension (:,:),allocatable     :: beam_list_long,beam_list_long_transp
   logical                                  ::did_not_find_any

did_not_find_any=.true.
   ! n1=min(size(beam_list(:,1)),beam_list_counter)
   !min(size(beam_list(:,1)),sol_counter) ! if there are fewer solutions than the beam_sz then use only the known solutions
   n2=size(beam_list(1,:))
   !  n1_long=n1+1
   !write(0,*) 'warp_mod 1', cst_wks(1)
   !  allocate(beam_list_long(n1_long,n2))
   !  beam_list_long=0.
   min_wake_value=cst_wks(1)
   min_wake_position=1
   !write(0,*) 'warp_mod 2'
!   write(0,*) 'wake_counter',wake_counter
!!$write(0,*) 'beam_list'
!!$write(0,*) beam_list(1:n1,:)
   ! make a list of nearby warped wakes
   wakeloop: do ig=1,wake_counter  !loop over each wake
      n1=min(size(beam_list(:,1)),beam_list_counter)
      n1_long=n1+1
      allocate(beam_list_long(n1_long,n2),beam_list_long_transp(n2,n1_long))

      beam_list_long(1:n1,:)=beam_list(1:n1,:)
      old_i=wrp_wks(i-1,j,1,ig)  ;  old_j=wrp_wks(i-1,j,2,ig)

      nearby: if (new_i-sd    <=old_i  .and.new_i   >=old_i.and.\
         new_j-sd/2  <=old_j  .and.new_j+sd/2>=old_j) then
 
did_not_find_any=.false.
         ! add it to the array
         beam_list_long(n1_long,1)=cst_wks(ig)+add_cost  !set cost
         beam_list_long(n1_long,2)=ig           !set position
         beam_list_long(n1_long,3)=new_i        !new i
         beam_list_long(n1_long,4)=new_j        !new j 
  !       write(0,*) 'newi/newj',new_i,new_j
!!$ write(0,*) 'beam_list_long(n1_long,3)', beam_list_long(n1_long,3)
!!$write(0,*) 'beam_list_counter', beam_list_counter
  !       write(0,*) 'n1/n2/n1_long',n1,n2,n1_long

         if (beam_list_counter<=size(beam_list(:,1))) then  !for the first solution at the stage
            beam_list(beam_list_counter,:)=beam_list_long(beam_list_counter+1,:)
  !          write(0,*) 'not sorting'
         else
    !        write(0,*) 'sorting'
            !sort the array
      !      write(0,*) 'beam_list_long before sort'
!!$            do ir=1,n1_long 
!!$               write(0,*) beam_list_long(ir,:)
!!$            end do
            beam_list_long_transp=transpose(beam_list_long)
      !      write(0,*) 'here'
            !beam_list_long_tr=reshape(beam_list_long,(/n2,n1_long/))
            !     call quick_sort(beam_list_long,1,n1_long,n2)  !sort by cost
      !      write(0,*) 'here'
            call quick_sort(beam_list_long_transp,1,n2,n1_long)  !sort by cost
            !beam_list_long=reshape(beam_list_long_tr,(/n1_long,n2/))
     !       write(0,*) 'beam_list_long after sort'
            beam_list_long=transpose(beam_list_long_transp)
!!$            do ir=1,n1_long 
!!$               write(0,*) beam_list_long(ir,:)
!!$            end do
            !stop

            !truncate the array
            beam_list(1:n1,:)=beam_list_long(1:n1,:)
         end if
         beam_list_counter=beam_list_counter+1
 
      end if nearby
     

      deallocate(beam_list_long,beam_list_long_transp)

   end do wakeloop
if (did_not_find_any) then
write(0,*) 'error....found no warped wakes'
stop
end if


!!$   write(0,*) 'sol_counter',sol_counter
!!$   write(0,*) 'beam_list out'
!!$   do ig=1,min(beam_list_counter-1,n1) 
!!$      write(0,*) beam_list(ig,:)
!!$   end do

   ! deallocate(beam_list_long)
 end subroutine beam_wake_list

 subroutine apply_beam_list(iq,jq,wrp_wks,cost_wks,beam_list,beam_list_counter,wake_counter)
   integer 	                                :: it,n1,iq,jq,a1,a2,a3,a4,beam_list_counter,wake_counter
   integer,    dimension (:,:,:,:)              :: wrp_wks
   integer,    dimension (:,:,:,:), allocatable :: wrp_wks_new
   real,    dimension (:)                      :: cost_wks
   real,    dimension (:), allocatable          :: new_cost_wks
   real,    dimension (:,:)                :: beam_list

  ! write(0,*) 'applying beam list'

   n1=min(size(beam_list(:,1)),beam_list_counter-1)
   a1=size(wrp_wks(:,1,1,1))
   a2=size(wrp_wks(1,:,1,1))
   a3=size(wrp_wks(1,1,:,1))
   a4=size(wrp_wks(1,1,1,:))
   allocate(wrp_wks_new(a1,a2,a3,a4),new_cost_wks(size(cost_wks)))

   do it=1,n1
      new_cost_wks(it)=beam_list(it,1)
      wrp_wks_new(:,:,:,it)=wrp_wks(:,:,:,beam_list(it,2))
      wrp_wks_new(iq,jq,1,it)=beam_list(it,3)
      wrp_wks_new(iq,jq,2,it)=beam_list(it,4)
   end do
   wrp_wks=wrp_wks_new
   cost_wks=new_cost_wks
   wake_counter=n1
  !write(0,*) 'wake_counter',wake_counter


   deallocate(wrp_wks_new,new_cost_wks)

 end subroutine apply_beam_list




   logical function IsNew(vallist,counter,newval)
     integer            :: counter,it
     real                :: newval
     real, dimension(:)  :: vallist

     IsNew=.true.   
     if (counter>0) then
        do it=1, counter   !loop over vallist looking for newval
           if (vallist(it)==newval) then
              IsNew=.false.
           end if
        end do
     end if

   end function IsNew

   subroutine apply_shift(image_in,image_out,wake)
     integer :: it,jt,nj,ni
     integer, dimension(:,:,:)  :: wake
     real, dimension(:,:)       :: image_in, image_out

     nj=size(image_in(1,:)) ! number of columns
     ni=size(image_in(:,1)) ! number of rows


     do jt=1,nj
        do it=1,ni

           image_out(it,jt)=image_in(wake(it,jt,1),wake(it,jt,2))
        end do
     end do


   end subroutine apply_shift

 end module warp_mod
